/***************************************************************************
                       Win32_Thread.c  -  description
                             -------------------
   Implementation of the THREAD API, using the Win32 thread library.

   When using this file:
      -make sure THREAD_FUNC is compiled using __stdcall
      -link with one of the following> LIBCMT.LIB (static)
                                       MSVCRT.LIB (dynamic)
      -the above is accomplished by using the multi-threaded
       C runtime libraries.
                             -------------------
    begin                : Sat Jul 17 2004
    copyright            : (C) 2004 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/


/* Public Functions */
/* Creates a new thread. */
THREAD new_THREAD(THREAD_FUNC f, void *args)
{
   DWORD tID;

   return (THREAD)_beginthreadex(NULL, 0, 
                                 (LPTHREAD_START_ROUTINE)f, 
                                 args, 0, &tID);
}

/* Current thread will wait for termination of given thread.
   Returns non-zero value for success. */
int join_THREAD(THREAD t, void **retval)
{
   if (WaitForSingleObject((HANDLE)t, INFINITE) != WAIT_OBJECT_0)
      return 0;
   if (retval)
      return GetExitCodeThread((HANDLE)t, (LPDWORD)retval);
   return 1;
}
