/***************************************************************************
                       cmdline_args.h  -  description
                             -------------------
   Stuff needed to deal with the command line arguments.
                             -------------------
    begin                : Fri Jul 16 2004
    copyright            : (C) 2004 by Dennis Lew
    email                : dennis_L76@yahoo.ca
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#ifndef __CMDLINE_ARGS__
#define __CMDLINE_ARGS__

#include "common/typedefs.h"
#include "common/File.h"
#ifdef __DVD_INPUT__
# include "dvd/dvd_input.h"
#endif


/* Structure containing all parameters for this application */
typedef struct {
   u16         req, loop, prog_num, PCR_PID, video_PID, audio_PID;
   double      start_time;
   const char *filename;
#ifdef __DVD_INPUT__
   u32         chapter;
   DVD_PTR     dvd;
#endif
   FILE_PTR    fp;
} APP_PARAMS;

/* req values */
#define PLAY_FIRST         0
#define PLAY_PROG          1
#define PLAY_STREAMS       2
#define DISPLAY_PIDS       3
#define DISPLAY_RATES      4
#define DISPLAY_PAT        5
#define DISPLAY_PMT        6
#define DISPLAY_DVD_INFO   7

/* Return values */
#define CMDLINE_DONE     1
#define CMDLINE_USAGE    0
#define CMDLINE_ERROR   -1

#ifdef __cplusplus
extern "C" {
#endif

/* Parse the given command line arguments, starting with argv[idx].
   Returns: one of the CMDLINE_* values, or a positive number
            indicating the next argv[] to be parsed
 */
int  CMDLINE_parse(int idx, int argc, char *argv[], APP_PARAMS *params);

/* Display the usage message */
void CMDLINE_usage(char *arg0);

#ifdef __cplusplus
};
#endif

#endif
